#!/usr/bin/perl
 
########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#### EDIT HERE -- FOR WINDOWS/IIS BASED INSTALLATIONS ONLY #######

$config_cgi = "../config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO config.cgi

# THE PATH ON A WINDOWS INSTALLATION WILL LOOK SOMETHING LIKE THIS:
# $config_cgi = "c:/inetpub/webpub/cgi-bin/pseek/config.cgi";

#### DO NOT CHANGE ANYTHING BELOW THIS LINE #################

#use FindBin;
#use lib $FindBin::Bin;
use CGI;
use DBI;
use acs;
use obbuild;

&get_setup;
$q = CGI->new;

acs::check_access($username, $password, $q->param('username'), $q->param('password'));

##################################################################################

print "Content-type: text/html\n\n";
if ($q->param('fct') eq "") {&start;}
if ($q->param('fct') eq "accept_modification") {&accept_modification;}
if ($q->param('fct') eq "accept_modification_save") {&accept_modification_save;}

if ($q->param('fct') eq "reject_modification") {&reject_modification;}
if ($q->param('fct') eq "reject_modification_save") {&reject_modification_save;}

if ($q->param('fct') eq "password_retrieval") {&password_retrieval;}
if ($q->param('fct') eq "password_retrieval_save") {&password_retrieval_save;}

##################################################################################

sub password_retrieval_save
{

if ($q->param('from_name') eq ""){acs::problem_popup("You have to supply a name from whom email is sent.");}
if ($q->param('from_email') eq ""){acs::problem_popup("You have to supply an email address from where email is sent.");}
if ($q->param('email_subject') eq ""){acs::problem_popup("The email needs a subject.");}
if ($q->param('email_message') eq ""){acs::problem_popup("The email needs a message.");}

open (AME, "> $data_dir/retrieve_pass.eml");
	print AME $q->param('from_name') . "\n";
	print AME $q->param('from_email') . "\n";
	print AME $q->param('email_subject') . "\n";
	print AME $q->param('email_message') . "\n";
close (AME);


$hbox = acs::get_heading_box("$web_url/ic_email4.gif", "Password Retrieval Email Saved", qq[<a href="$admin_url/admin16.cgi">Click here to continue.</a>]);

print <<END_OF_SAVED;

<html>
<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css" />  
</head>
<body>
$hbox
</body>
</html>

END_OF_SAVED

}


sub password_retrieval
{

$emailmsg = acs::get_file_contents("$data_dir/retrieve_pass.eml");

@elines = split (/\n/, $emailmsg);

$from_name = $elines[0];
$from_email = $elines[1];
$email_subject = $elines[2];

$lnc = 0;
foreach $line (@elines)
	{
	if ($lnc > 2)
		{
		$email_message = $email_message . $line . "\n";
		}
	$lnc++;
	}


$hbox = acs::get_heading_box("$web_url/ic_email4.gif", "Password Retrieval Email ", qq[This email is sent to users requesting their passwords to modify links.]);


$helpb = acs::quick_help("Variables Available For Use In This Email ",qq[<p><strong>%%link_details%% <br>
</strong>This is replaced by the link passwords, titles, descriptions, etc... </p>
]); 



print <<END_OF_PSRET;

<html>

<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css" />  
</head>

<body>

$hbox


<form method="POST" action="$admin_url/admin19.cgi">
  <input type="hidden" name="fct" value="password_retrieval_save"><input type="hidden"
  name="from" value>
  
   <table border="0" cellspacing="1" width="100%" cellpadding="6" bgcolor="#DDDDDD">
    <tr>
      <td colspan="2" background="$web_url/bar6.gif" bgcolor="#FFFFFF" class="normaltext"><strong>Email Details:</strong></td>
      </tr>
    <tr>
      <td width="15%" bgcolor="#FFFFFF" class="normaltext">From Name: </td>
      <td width="85%" bgcolor="#FFFFFF"><input type="text" name="from_name" size="40"
       value="$from_name" style="width:100%"> </td>
    </tr>
    <tr>
      <td width="15%" bgcolor="#FFFFFF" class="normaltext">From Email: </td>
      <td width="85%" bgcolor="#FFFFFF"><input type="text" name="from_email" size="40"
       value="$from_email" style="width:100%"> </td>
    </tr>
    <tr>
      <td width="15%" bgcolor="#FFFFFF" class="normaltext">Email Subject: </td>
      <td width="85%" bgcolor="#FFFFFF"><input type="text" name="email_subject" size="57"
       value="$email_subject" style="width:100%"> </td>
    </tr>
    <tr>
      <td width="15%" valign="top" bgcolor="#FFFFFF" class="normaltext">Message: </td>
      <td width="85%" bgcolor="#FFFFFF"><textarea rows="24" name="email_message" cols="77" style="width:100%">$email_message</textarea> </td>
    </tr>
    <tr>
      <td width="15%" bgcolor="#FFFFFF"></td>
      <td width="85%" bgcolor="#FFFFFF"><input type="submit" value="   Save   " name="B1"> </td>
    </tr>
  </table>
  <table border="0" cellpadding="0"
  cellspacing="0" width="100%" background="$web_url/shadow.gif">
    <tr>
      <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font> </td>
      <td width="99%"></td>
    </tr>
  </table>

  
$helpb

</form>



</body>
</html>

END_OF_PSRET




}



sub reject_modification_save
{

if ($q->param('from_name') eq ""){acs::problem_popup("You have to supply a name from whom email is sent.");}
if ($q->param('from_email') eq ""){acs::problem_popup("You have to supply an email address from where email is sent.");}
if ($q->param('email_subject') eq ""){acs::problem_popup("The email needs a subject.");}
if ($q->param('email_message') eq ""){acs::problem_popup("The email needs a message.");}

open (AME, "> $data_dir/reject_modify.eml");
	print AME $q->param('from_name') . "\n";
	print AME $q->param('from_email') . "\n";
	print AME $q->param('email_subject') . "\n";
	print AME $q->param('email_message') . "\n";
close (AME);


if ($q->param('from') ne "")
	{
	$link = "$admin_url/admin18.cgi";
	}
	else
	{
	$link = "$admin_url/admin16.cgi";
	}



$hbox = acs::get_heading_box("$web_url/ic_email4.gif", "Modify Rejection Email Saved", qq[<a href="$link">Click here to continue.</a>]);


print <<END_OF_SAVED;

<html>
<head>
<title>Modify Rejection Email</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css" />  
</head>
<body>

$hbox

</body>
</html>

END_OF_SAVED

}



sub reject_modification
{

($extradfk) = acs::get_extra_vars;

if ($extradfk ne ""){$extradfk = "<font color=\"#8080FF\"><b>Listed below is extra field/key variables that may be used with this email.</b><br><br></b>$extradfk<b></font>";}


$emailmsg = acs::get_file_contents("$data_dir/reject_modify.eml");

@elines = split (/\n/, $emailmsg);

$from_name = $elines[0];
$from_email = $elines[1];
$email_subject = $elines[2];

$lnc = 0;
foreach $line (@elines)
	{
	if ($lnc > 2)
		{
		$email_message = $email_message . $line . "\n";
		}
	$lnc++;
	}


$from = $q->param('from');


$hbox = acs::get_heading_box("$web_url/ic_email4.gif", "Modify Rejection Email ", qq[This email is sent to a user when a link has been modified by the user and the users modification has not been accepted. (Via the control panel by the admin).]);


$helpb = acs::quick_help("Variables Available For Use In This Email ",qq[<p><strong>Variables Available For Use In This Email </strong></p>

<p><strong>%%title%% <br>
</strong>The title of the modified link. </p>

<p><strong>%%description%% </strong><br>
The description of the modified link. </p>

<p><strong>%%url%% <br>
</strong>The url of the link where modification changes has been approved. </p>

<p><strong>%%keywords%% <br>
</strong>The url of the link where modification changes has been approved. </p>

<p>$extradfk</p>
]); 


print <<END_OF_RJ;

<html>

<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css" />  
</head>

<body>

$hbox

<form method="POST" action="$admin_url/admin19.cgi">
  <input type="hidden" name="fct" value="reject_modification_save"><input type="hidden"
  name="from" value="$from">
  
<table border="0" cellspacing="1" width="100%" cellpadding="6" bgcolor="#DDDDDD">
    <tr>
      <td colspan="2" background="$web_url/bar6.gif" bgcolor="#FFFFFF" class="normaltext"><strong>Email Details:</strong></td>
      </tr>
    <tr>
      <td width="15%" bgcolor="#FFFFFF" class="normaltext">From Name: </td>
      <td width="85%" bgcolor="#FFFFFF"><input type="text" name="from_name" size="40"
      value="$from_name" style="width:100%"> </td>
    </tr>
    <tr>
      <td width="15%" bgcolor="#FFFFFF" class="normaltext">From Email: </td>
      <td width="85%" bgcolor="#FFFFFF"><input type="text" name="from_email" size="40"
      value="$from_email" style="width:100%"> </td>
    </tr>
    <tr>
      <td width="15%" bgcolor="#FFFFFF" class="normaltext">Email Subject: </td>
      <td width="85%" bgcolor="#FFFFFF"><input type="text" name="email_subject" size="57"
      value="$email_subject" style="width:100%"> </td>
    </tr>
    <tr>
      <td width="15%" valign="top" bgcolor="#FFFFFF" class="normaltext">Message: </td>
      <td width="85%" bgcolor="#FFFFFF"><textarea rows="24" name="email_message" cols="77" style="width:100%">
$email_message
</textarea> </td>
    </tr>
    <tr>
      <td width="15%" bgcolor="#FFFFFF"></td>
      <td width="85%" bgcolor="#FFFFFF"><input type="submit" value="   Save   " name="B1"> </td>
    </tr>
  </table>
  </center></div><div align="center"><center><table border="0" cellpadding="0"
  cellspacing="0" width="100%" background="$web_url/shadow.gif">
    <tr>
      <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_ </font></td>
      <td width="99%"></td>
    </tr>
  </table>
</form>

$helpb




</body>
</html>

END_OF_RJ


}



sub accept_modification_save
{

if ($q->param('from_name') eq ""){acs::problem_popup("You have to supply a name from whom email is sent.");}
if ($q->param('from_email') eq ""){acs::problem_popup("You have to supply an email address from where email is sent.");}
if ($q->param('email_subject') eq ""){acs::problem_popup("The email needs a subject.");}
if ($q->param('email_message') eq ""){acs::problem_popup("The email needs a message.");}

open (AME, "> $data_dir/accept_modify.eml");
	print AME $q->param('from_name') . "\n";
	print AME $q->param('from_email') . "\n";
	print AME $q->param('email_subject') . "\n";
	print AME $q->param('email_message') . "\n";
close (AME);

if ($q->param('from') ne "")
	{
	$link = "$admin_url/admin18.cgi";
	}
	else
	{
	$link = "$admin_url/admin16.cgi";
	}


$hbox = acs::get_heading_box("$web_url/ic_email4.gif", "Modify Acceptance Email Saved", qq[<a href="$link">Click here to continue.</a>]);

print <<END_OF_SAVED;

<html>
<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css" />  
</head>
<body>

$hbox

</body>
</html>

END_OF_SAVED

}





sub accept_modification
{

($extradfk) = acs::get_extra_vars;

if ($extradfk ne ""){$extradfk = "<font color=\"#8080FF\"><b>Listed below is extra field/key variables that may be used with this email.</b><br><br></b>$extradfk<b></font>";}
 

$emailmsg = acs::get_file_contents("$data_dir/accept_modify.eml");

@elines = split (/\n/, $emailmsg);

$from_name = $elines[0];
$from_email = $elines[1];
$email_subject = $elines[2];

$lnc = 0;
foreach $line (@elines)
	{
	if ($lnc > 2)
		{
		$email_message = $email_message . $line . "\n";
		}
	$lnc++;
	}

$from = $q->param('from');


$hbox = acs::get_heading_box("$web_url/ic_email4.gif", "Modify Acceptance Email", qq[This email is sent to a user when a link has been modified by the user and the users modification has been accepted (via the control panel by the admin).]);


$helpb = acs::quick_help("Variables Available For Use In This Email ",qq[<p align="left"><strong>%%title%% <br>
</strong>The title of the modified link. </p>

<p align="left"><strong>%%description%% </strong><br>
The description of the modified link. </p>

<p align="left"><strong>%%url%% <br>
</strong>The url of the link where modification changes has been approved. </p>

<p align="left"><strong>%%keywords%% <br>
</strong>The url of the link where modification changes has been approved. </p>

<p>$extradfk </p>
]); 


print <<END_OF_AE;

<html>
<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css" />  
</head>
<body>

$hbox

<form method="POST" action="$admin_url/admin19.cgi">
  <input type="hidden" name="fct" value="accept_modification_save"><input type="hidden"
  name="from" value="$from"><table border="0" cellspacing="1" width="100%" cellpadding="6"
  bgcolor="#DDDDDD" height="46">
    <tr>
      <td colspan="2" background="$web_url/bar6.gif" bgcolor="#FFFFFF" class="normaltext"><strong>Email Details:</strong></td>
    </tr>
    <tr>
      <td width="15%" bgcolor="#FFFFFF" class="normaltext">From Name: </td>
      <td width="85%" bgcolor="#FFFFFF"><input type="text" name="from_name" size="40" value="$from_name" style="width:100%"> </td>
    </tr>
    <tr>
      <td width="15%" bgcolor="#FFFFFF" class="normaltext">From Email: </td>
      <td width="85%" bgcolor="#FFFFFF"><input type="text" name="from_email" size="40" value="$from_email" style="width:100%"> </td>
    </tr>
    <tr>
      <td width="15%" bgcolor="#FFFFFF" class="normaltext">Email Subject: </td>
      <td width="85%" bgcolor="#FFFFFF"><input type="text" name="email_subject" size="57" value="$email_subject" style="width:100%"> </td>
    </tr>
    <tr>
      <td width="15%" valign="top" bgcolor="#FFFFFF" class="normaltext">Message: </td>
      <td width="85%" bgcolor="#FFFFFF"><textarea rows="24" name="email_message" cols="77" style="width:100%">$email_message</textarea> </td>
    </tr>
    <tr>
      <td width="15%" bgcolor="#FFFFFF"></td>
      <td width="85%" bgcolor="#FFFFFF"><input type="submit" value="   Save   " name="B1"> </td>
    </tr>
  </table>
  <table border="0" cellpadding="0" cellspacing="0" width="100%"
  background="$web_url/shadow.gif">
    <tr>
      <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font> </td>
      <td width="99%"></td>
    </tr>
  </table>
</form>


$helpb

</body>
</html>

END_OF_AE

}



sub start
{

print <<END_OF_EM;

<html>
<head>
<title>PowerSeek</title>
</head>
<body>
<table border="0" cellpadding="6" cellspacing="1" width="100%">
  <tr>
    <td width="1%" valign="top"><p align="center"><img src="$web_url/ic_email4.gif"></td>
    <td width="95%" valign="top"><strong><font face="Arial" size="4" color="#000000">Settings
     > </font><font face="Arial" size="4" color="#0000A0"> 'New Submission' and 'Modify Link'
    Emails<br>
    </font></strong><font face="Verdana" size="1">These emails are sent out to users when they
    submit new listings or modify listings.</font></td>
  </tr>
</table>
<hr noshade size="1" color="#F2F2F2">
<table border="0" cellspacing="1" width="100%" cellpadding="6" bgcolor="#C0C0C0"
height="46">
  <tr>
    <td width="1%" bgcolor="#F4F4F4" height="30"><p align="center"><img
    src="$web_url/emls.gif"></td>
    <td width="99%" bgcolor="#FFFFFF" height="80"><font face="Verdana" size="1"><strong><a
    href="$admin_url/admin16.cgi?fct=edit_email&amp;email=welcome">Welcome Email</a><br>
    </strong>This email is sent when a submission takes place. It almost acts like an
    autoresponder because it is sent just after a user added a new listing via the 'add url'
    form. This is optional and you can disable this by <strong>clicking here.</strong></font></td>
  </tr>
  <tr>
    <td width="1%" bgcolor="#F4F4F4" height="30"><p align="center"><img
    src="$web_url/appeml.gif"></td>
    <td width="99%" bgcolor="#FFFFFF" height="80"><font face="Verdana" size="1"><strong><a
    href="$admin_url/admin16.cgi?fct=edit_email&amp;email=newsubmission">New Submission
    Acceptance Email</a><br>
    </strong>This email is sent to a user when his new submission has been approved for
    inclusion into the directory.</font></td>
  </tr>
  <tr>
    <td width="1%" bgcolor="#F4F4F4" height="30"><p align="center"><img
    src="$web_url/rjeml.gif"></td>
    <td width="99%" bgcolor="#FFFFFF" height="80"><font face="Verdana" size="1"><strong><a
    href="$admin_url/admin16.cgi?fct=edit_email&amp;email=submissionreject">New Submission
    Rejection Email</a><br>
    </strong>This email is sent to a user when his new submission has not been approved for
    inclusion into the directory.</font></td>
  </tr>
  <tr>
    <td width="1%" bgcolor="#F4F4F4" height="30"><p align="center"><img
    src="$web_url/infeml.gif"></td>
    <td width="99%" bgcolor="#FFFFFF" height="80"><font face="Verdana" size="1"><strong><a
    href="$admin_url/admin16.cgi?fct=edit_email&amp;email=submissioninform">New Submission
    Informer Email</a><br>
    </strong>This email is sent to you, to inform you that a new submission has been made.
    This is optional and you can disable this by <strong>clicking here</strong></font></td>
  </tr>
  <tr>
    <td width="1%" bgcolor="#F4F4F4" height="30"><img src="$web_url/appeml.gif"></td>
    <td width="99%" bgcolor="#FFFFFF" height="80"><font face="Verdana" size="1"><strong><a
    href="$admin_url/admin19.cgi?fct=accept_modification">Modify Acceptance Email</a><br>
    </strong>This email is sent to a user when a link has been modified by the user and the
    users's modification has been accepted.<strong></strong></font></td>
  </tr>
  <tr>
    <td width="1%" bgcolor="#F4F4F4" height="30"><img src="$web_url/rjeml.gif"></td>
    <td width="99%" bgcolor="#FFFFFF" height="80"><font face="Verdana" size="1"><strong><a
    href="$admin_url/admin19.cgi?fct=reject_modification">Modify Rejection Email<br>
    </a></strong>This email is sent to a user when a link has been modified by the user and
    the users's modification has not been accepted.<strong></strong></font></td>
  </tr>
</table>
</body>
</html>

END_OF_EM

}


####################################################################################


sub get_setup
{

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, "$config_cgi");
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
				$line =~ s/\n//g;
	
if ($line =~ /^DB_NAME/){$db_name = &get_setup_line($line, DB_NAME);}
if ($line =~ /^DB_USERNAME/){$db_username = &get_setup_line($line, DB_USERNAME);}
if ($line =~ /^DB_PASSWORD/){$db_password = &get_setup_line($line, DB_PASSWORD);}
if ($line =~ /^MYSQL_HOSTNAME/){$mysql_hostname = &get_setup_line($line, MYSQL_HOSTNAME);}
if ($line =~ /^MYSQL_PORT/){$mysql_port = &get_setup_line($line, MYSQL_PORT);}

if ($line =~ /^SCRIPT_URL/){$script_url = &get_setup_line($line, SCRIPT_URL);}
if ($line =~ /^ADMIN_URL/){$admin_url = &get_setup_line($line, ADMIN_URL);}
if ($line =~ /^WEB_URL/){$web_url = &get_setup_line($line, WEB_URL);}
if ($line =~ /^WEB_DIR/){$web_dir = &get_setup_line($line, WEB_DIR);}
if ($line =~ /^DATA_DIR/){$data_dir = &get_setup_line($line, DATA_DIR);}

if ($line =~ /^USERNAME/){$username = &get_setup_line($line, USERNAME);}
if ($line =~ /^PASSWORD/){$password = &get_setup_line($line, PASSWORD);}


			}
	close (STP);
	
	}
}




sub get_setup_line
{
my ($setup_line, $setup_var) = @_;
$crit = "\"";
$setup_line =~ m/$crit/g;
$r1 = pos($setup_line);
$setup_line =~ m/$crit/g;
$r2 = pos($setup_line);
$setup_line = substr($setup_line, $r1, ($r2 - $r1 - 1));
$return_val = $setup_line;
return ($return_val);
}

#### END CONFIGURATION ########################################################

